Rebol [
	Title: "cy-layout"
	Date: 25-feb-2005
	File: %cy-layout.r
	version: 0.3.0
	Author: "Jocko"
	Purpose: "modles de layout pour script-wizard"
	Comment: {utilisation de la librairie de Cyphre, exemples de Cyphre}
	Help: {on peut ajouter ses propres modles, en respectant la syntaxe:
		nom-du-modele: {main: layout [blabla ...] view main}
		et en ajoutant nom-du-modele  liste-main}
]



cy-liste-main: ["menu-cy" "liste-cy" ]
insert liste-main cy-liste-main

liste-cy: {
do %styles/my-list.r

demo-data: copy []
list-styles: stylize/master [
 cell: label
         edge [size: 1x1 color: 180.180.180 effect: 'bevel]
         font [style: none color: black shadow: none]
         with [color: 180.180.180]
 ]

main: layout [
	style text text with [color: red]
	style field field edge [size: 1x1]
 	style check check edge [size: 1x1]
 	style info info  edge [size: 1x1]
 	style button button edge [size: 1x1] gray red
	styles list-styles
        
   lst: my-list 600x400 columns [
          cell 300 
          cell 100 
          cell 300
   ]
   data demo-data;[["1" [text "2" color red] "3"]["4" "5" "6"]]
   rowbar ["File" "Size" "Date"] 
   row-highlight
   line-colors reduce [ivory snow]
	across
   button "test" [
     windir: read %/C/
     foreach element windir [
        info: info? join %/C/ element
        insert/only tail demo-data compose/deep [
           (element)
           (info/size)
           (info/date)
         ]
     ]
   lst/update-list
  ]
  button "a propos" [aPropos]
   button "quitter" [quit]
]
view main }

menu-cy: {
do %styles/ctx-menu.r
win-size: 640x480
main: layout [
	size win-size origin 0 space 0 across
	mn: menu alpha 0  data compose/deep [
		"File    " [
			%gfx/menu_link_local.gif "New" [clear t1/text show t1]
			%gfx/menu_folder_closed.gif "Open" # "Ctrl+O" [t1/text: read to-file request-file show t1]
			%gfx/menu_root.gif "Close" # "Ctrl+W" [clear t1/text show t1]
			bar
			%gfx/menu_folder_closed.gif "Save" # "Ctrl+S" [write to-file request-file t1/text]
			"Save As..." [write to-file request-file t1/text]
			bar
			"Print..." [print t1/text]
			disable "Print Preview"
			bar
			"Recent Files"
			bar
			"Exit" # "Alt+F4" [quit]
		]
		"Edit    " [
			"Undo"
			"Redo"
			bar
			disable "Cut"
			disable "Copy" 
			disable "Paste"
			bar
			+ "Select All"
			"Select Line"
			"Delete" sub [
				"Delete Line"
				+ "Delete to start" 
				"Delete to end"
			]
			bar
			"Date/Time" [append t1/text rejoin[now newline] show t1]
		]
		"Help    " [
			"Index"
			"Using Help"
			"About..." [apropos]
		]
	]
	return
	 t1: area wrap (win-size - 16x22) font [name: font-fixed] para [tabs: 28 origin: 4x4]
     s1: slider to-pair reduce [16 win-size/y] [scroll-para t1 s1]
]
view/new center-face main }

