Rebol [
	Title: "lib-apropos"
	Date: 6-May-2004
	File: %lib-apropos.r
	version: 0.4.0
	Author: "Jocko"
	Purpose: "modles de fonctions apropos pour script-wizard"
	Comment: {certains modles sont tirs des exemples fournis sur le forum Rebol de Codeur.org,
	sur le FWK rebol.agora-dev.org, ou le livre de O. Auverlot}
	Help: {on peut ajouter ses propres modles, en respectant la syntaxe:
		nom-du-modele: {aPropos: does [blabla ...]}
		et en ajoutant "nom-du-modele"  'liste-aPropos}
]

;------------------ 

liste-aPropos: ["simple" "complete" "defilante"]

simple: {aPropos: does [
	aid: layout[
	style txt h3 center 180
	style mvh1 h1 black center 180
	backdrop snow
	mvh1 rejoin [ ssh/title " v" ssh/version]
	txt ssh/purpose
	txt ssh/author 
	txt to-string ssh/date
	pad 50x20
	btn 80x24 " ok " [unview aid]] view/new center-face aid]
	}

complete: {aPropos: func [/local lay][
    lay: copy [
    	backdrop snow ;220.200.160
        across origin 0x0 space 0x0
		style vtext text black bold with [
			feel: none
			append init [font: make font []]
		]
		style text text 200 black with [
			append init [font: make font [colors: [0.0.0 0.0.255]]]
		]
        image logo.gif box 200x24 
            effect [merge gradmul 1x0 0.0.0 128.128.128] return
        pad 10x10 guide
    ]
    foreach [name value] third ssh [
        if not none? value [
            append lay reduce [
                'vtext mold :name 'tab 'text form value
            ]
            switch/default type?/word value [
                string! [append lay [with [feel: none]]]
                email! [append/only lay compose/deep [
                    alive?: true error? try [emailer/to (value)]
                ]]
                url! [append/only lay compose/deep [
                    error? try [browse (value)]
                ]]
                file! [append/only lay compose/deep [
                    error? try [editor (value)]
                ]]
            ][append lay [with [feel: none]]]
            append lay 'return
        ]
    ]
    append lay [
        pad -10x10 
        box 200x24 effect [merge gradmul 1x0 128.128.128 0.0.0]
        button "Close" black [unview/only lay] edge [size: none]
    ]
    view/new/title center-face lay: layout lay 
        join "aPropos " ssh/title
]}

defilante: {aPropos: does [
	aid: layout [
	across pad 50 image  logo.gif
	below
    h1 center bold 200x30 center rejoin [ ssh/title " v" ssh/version] ;yellow
    credits: text black bold center 200x140 rate 30 para [origin: 0x+100]
        feel [engage: func [f a e] [
            if a = 'time [f/para/origin: f/para/origin - 0x1 show f]
        ]
    ]
    pad 50x20
    btn 100x24 " ok " [unview aid]] 

credits/text: rejoin ["Remplacez ce texte" newline newline "par ce que vous souhaitez" newline newline 
"C'est l'affaire d'une minute" newline newline "Seul REBOL le permet..."]

append credits/text rejoin [newline newline "-" newline newline ssh/author]

view/new center-face aid]
}

