Rebol [
	Title: "lib-layout"
	Date: 6-May-2004
	File: %lib-layout.r
	version: 0.4.0
	Author: "Jocko"
	Purpose: "modles de layout pour script-wizard"
	Comment: {certains modles sont tirs des exemples fournis sur le forum Rebol de Codeur.org,
	sur le FWK rebol.agora-dev.org, ou le livre de O. Auverlot}
	Help: {on peut ajouter ses propres modles, en respectant la syntaxe:
		nom-du-modele: {main: layout [blabla ...] view main}
		et en ajoutant "nom-du-modele"  'liste-main}
]

liste-main: ["lanceur" "formulaire" "texte1" "liste1" "liste2" "editeur" "panneaux1" "panneaux2" "plein_ecran"]

lanceur: {main: layout [
	style mbtn btn yellow 120x24
	h3 120x24 center to-string now/date
	banner 120x24 "00:00:00" rate 0:00:02
	        feel [engage: func [face act evt] [face/text: now/time  show face] ]
	pad 0x30
	mbtn "btn 1" []
	mbtn "btn 2" []
	mbtn "btn 3" []
	pad 0x30
	mbtn "diter" green [editor ssh/file]
	mbtn "relancer" [do ssh/file]
	mbtn " propos" [aPropos]
	mbtn "quitter" orange [quit]
]
view center-face main}

formulaire: {main: layout [
        across space 2x8
        style mlabel vtext bold 100x24 middle right
        style mbar box 306x3 edge [size: 1x1 color: water effect: 'bevel]
		backdrop effect [gradient 0x1 water silver]
        vh2 300 center "Exemple de formulaire" [aPropos]
        return
        mbar return

        mlabel "Nom"     f1: field 200 return
        pad 120 c1: check vtext "Programmeur" bold return
        pad 120 c2: check vtext "Operateur" bold return
        mlabel "Adresse Email" f2: field return
        mlabel "Tlphone"  f3: field return
        mlabel "Commentaires" f4: area wrap 200x100 return

        mbar return
        pad 40 space 100
        btn-enter 60 "Enregistrer" [ ]
        btn-cancel 60 "quitter" [quit]
    ]
    view center-face main}

texte1: {main: layout [
	backdrop silver
	style mbtn btn 100x20 yellow
	ttr: vh2 rejoin [ssh/title  "   v " ssh/version]
	box brick 420x2
	across
	tl: area 400x250 snow wrap
	sl: slider 16x250 [scroll-para tl sl]
	return
	box brick 420x2
	return
	across
	mbtn "btn1" []
	mbtn "btn2" []
	mbtn "btn3" []
	mbtn "btn4" []
	return
	mbtn "diter" green [editor to-file ssh/file]
	mbtn " propos" yellow [aPropos]
	pad 110x0	
	mbtn "quitter" orange [quit]
	return
]
view center-face main}

liste1: {
	example: load %.
	main: layout [
	backdrop silver
	style mbtn btn 100x20 yellow
	across
	image logo.gif 
	ttr: vh2 200x24 rejoin [ssh/title "   v " ssh/version] center [aPropos]
	return
	below
	box brick 420x2
	tt1: text-list 420X250 data copy example 
	box brick 420x2
	across
	mbtn "diter" green [editor to-file tt1/picked]
	mbtn "aide"  [either file? ssh/help [error? try [browse ssh/help]][alert ssh/help]]
	mbtn " propos" yellow [aPropos]
	mbtn "quitter" orange [quit]
	return
]
view center-face main}


liste2: {
	example: load %.
	main: layout [
	origin 0x0 space 0x0
	backdrop silver 
	style mbtn btn 100x20 yellow	
	across
	image logo.gif  box 420x24 effect [merge gradmul 1x0 0.0.0 128.128.128 ]return
	below
	mbtn "diter" green [editor to-file tt1/picked]
	mbtn " propos" yellow [aPropos]
	at 0x235
	mbtn "aide"  [either file? ssh/help [error? try [browse ssh/help]][alert ssh/help]]
	mbtn "quitter" orange [quit]
	at 100x0
	below
	ttr: vh2 420x24 rejoin [ssh/title "   v " ssh/version] center  [aPropos]
	tt1: text-list 420x250 data copy example 
]
view center-face main}

editeur: {
win-size: 640x480
	main:  layout/offset [
        style tx vtext bold 60x22 font [colors: [0.0.0 200.200.200]] middle center
        size win-size origin 0 space 0 across
        tx "Ouvrir" [t1/text: read to-file request-file show t1]
        tx "Nouveau" [clear t1/text show t1]
        tx "Sauver" [write to-file request-file t1/text]
        tx "Info" [apropos]
        tx "Quitter" [quit]
        text "Fichier:" bold black right middle 60x22
        f1: info to-pair reduce [(win-size/x - 360) 22] base-color 
        return
        t1: area wrap (win-size - 16x22) font [name: font-fixed] para [tabs: 28 origin: 4x4]
        s1: slider to-pair reduce [16 win-size/y] [scroll-para t1 s1]
    ] 0x0
view center-face main}

panneaux1: {main: layout [
	style btn1 btn 100x20
	origin 0x0 space 0x0
	backdrop water
	across
	btn1 "fichier " [panels/pane: panel1 show panels]
	btn1 "mode	" [panels/pane: panel2 show panels]
	btn1 "info " [aPropos] 
	vh4 ssh/Title
	
	return
	;box 640x2 maroon
	return
	panels: box 100x400
	box 2x400 maroon
	cb1: box 540x400 coal
]

panel1: layout [size 100x400
	style btn1 btn 100x20
	origin 0x0 space 0x0
	backdrop gray
	btn1 "charger" []
	btn1 "enregistrer" []
	btn1 "quitter" [quit]
]
panel2: layout [size 100x400
	style mrotary rotary gray 100x20
	origin 0x0 space 0x0
	backdrop gray
	e1: mrotary "positif" "ngatif" []
	e2: mrotary "couleur" "noir et blanc" []
	e3: mrotary "normal" "contrast" []
]

panel1/offset: 0x0
panel2/offset: 0x0
panels/pane: panel1

view center-face main}

panneaux2: {
main: layout [
	style btn1 h4 left 100x20
	origin 0x0 space 0x0
	backdrop gray
	across
	vh4 ssh/Title
	return
	box 640x2 black
	return
	panel [
		origin 0x0 space 0x0
		btn1 "page1" [panels/pane: panel1 show panels]
		btn1 "page2" [panels/pane: panel2 show panels]
		btn1 "a propos" [aPropos]
		btn1 "quitter" [quit]
	]
	box 1x400 black
	panels: box 540x400 coal
]

panel1: layout [size 540x400
	origin 0x0 space 0x0
	across
	tl: area 524x400 snow wrap
	sl: slider 16x400 [scroll-para tl sl]
	return
]
panel2: layout [size 540x400
	backdrop white effect [grid 1000x8 0x0 gray]
]

panel1/offset: 0x0
panel2/offset: 0x0
panels/pane: panel1

view center-face main}


plein_ecran: {
	screensize: system/view/screen-face/size
	step: screensize / 80x60
	; exemple de fonction: lance le script Rebol ou ouvre le fichier
	lance-script: func [face] [if error? try [do to-file face/text] [try [browse to-file face/text]]]
	tdir: load %.
	mainwin: copy [
	size screensize
	backdrop gray effect [grid 2000x8 0x0 blue]
	style mbtn vh2 white
	at step * 1x1
	guide
	mbtn "a propos" [aPropos]]
	forall tdir[append mainwin reduce ['mbtn first parse/all (to-string tdir/1)  "/" [lance-script face]]]
	append mainwin [
	at step * 1x58
	mbtn "Quitter" [quit]
	return]
	main: layout mainwin
	view center-face main}