REBOL [
	Title: "script wizard"
	Date: 18-Mar-2004
	File: %script-wizard.r
	Version: 0.8.0
	Author: "Jocko"
	Needs: [%lib-layout.r %lib-apropos.r %cy-layout.r ] ;%mes-layout.r %mes-apropos.r
	Purpose: {
        Crer un squelette de script pour simplifier le travail
        d'criture du programme
    }
	Comments: {
    	fonctions de mise en page tires de script-cleaner 
    	de Carl Sassenrath
    	styles raliss par plusieurs reboleurs
    	utilisation des styles et exemples de cyphre}
	Help: %aide-wizard.html
]
;----test version du systme --------------

if system/version < 1.2.8 [alert "utilisable avec view1.2.8 et plus" quit]

;---- paramtres par dfaut ----------------

prog-title: "essai"
prog-file: %essai.r
prog-version: 0.1.0
prog-comment: "Script cr par wizard 0.8.0"
prog-help: "pas d'aide disponible"
prog-author: any [system/user/name "..."]

;-----chargement des librairies de modles ---

foreach el system/script/header/needs [if (exists? el) [do el]]

;-------------------------------------------

script-cleaner: make object! [

	out: none ; output text
	spaced: off ; add extra bracket spacing
	indent: "" ; holds indentation tabs

	emit-line: func [] [append out newline]

	emit-space: func [pos] [
		append out either newline = last out [indent] [
			pick [#" " ""] found? any [
				spaced
				not any [find "[(" last out find ")]" first pos]
			]
		]
	]

	emit: func [from to] [emit-space from append out copy/part from to]

	set 'clean-script func [
		"Returns new script text with standard spacing."
		script "Original Script text"
		/spacey "Optional spaces near brackets and parens"
		/local str new
	] [
		spaced: found? spacey
		clear indent
		out: append clear copy script newline
		parse script blk-rule: [
			some [
				str:
				newline (emit-line) |
				#";" [thru newline | to end] new: (emit str new) |
				[#"[" | #"("] (emit str 1 append indent tab) blk-rule |
				[#"]" | #")"] (remove indent emit str 1) break |
				skip (set [value new] load/next str emit str new) :new
			]
		]
		remove out ; remove first char
	]
]


script-composer: make object! [
	out: "" ; output text

	emit: func [str] [append out str]
	emit-line: func [str] [append out join str newline]

	set 'compose-header func [][
	hdr: make object![
	Title: wf1/text 
	Date: now/date
	Version: prog-version
	File: to-file wf2/text
	Author: wf4/text 
	Purpose: wf5/text 
	Comments: wf6/text 
	Help: do [ either (first wf7/text) = #"%" [to-file next wf7/text][wf7/text]]
	]
	hdr
	]
	set 'compose-lays func [blk] [
		foreach el blk [emit reduce to-block el emit newline]
	]

	set 'compose-file func [file blk] [
		out: copy mold compose-header
		replace out "make object!" "Rebol"
		emit newline 
		emit-line "ssh: system/script/header"	
		emit newline	
		foreach el blk [emit reduce to-block el emit newline]
	]
]

wiz-aPropos: func [/local lay] [
	lay: copy [
		backdrop 200.200.240
		across origin 0x0 space 0x0
		style vtext text black bold with [
			feel: none
			append init [font: make font []]
		]
		style text text 200 black with [
			append init [font: make font [colors: [0.0.0 0.0.255]]]
		]
		image logo.gif box 200x24
		effect [merge gradmul 1x0 0.0.0 128.128.128] return
		pad 10x10 guide
	]
	foreach [name value] third system/script/header [
		if not none? value [
			append lay reduce [
				'vtext mold :name 'tab 'text form value
			]
			switch/default type?/word value [
				string! [append lay [with [feel: none]]]
				email! [append/only lay compose/deep [
						alive?: true error? try [emailer/to (value)]
					]]
				url! [append/only lay compose/deep [
						error? try [browse (value)]
					]]
				file! [append/only lay compose/deep [
						error? try [editor (value)]
					]]
			] [append lay [with [feel: none]]]
			append lay 'return
		]
	]
	append lay [
		pad -10x10
		box 200x24 effect [merge gradmul 1x0 128.128.128 0.0.0]
		button "Close" black [unview/only lay] edge [size: none]
	]
	view/new/title center-face lay: layout lay
	join "aPropos " system/script/header/title
]

aPropos: :wiz-aPropos

main-win-wizard: layout [
	across space 2x8
	style label vtext bold 120x24 middle right
	style bar box 320x3 edge [size: 1x1 color: water effect: 'bevel]
	style mbtn btn-enter 60 
	;style mrtr rotary 120 orange + 30.30.30
	style mrtr drop-down 120
	backcolor water 

	vh2 300 center rejoin [system/script/header/title "  v " system/script/header/version] [wiz-aPropos] return
	bar return

	label "Titre" wf1: field 200 prog-title return
	label "Nom du fichier" wf2: field 200 to-string prog-file return
	label "Date" wf3: field 200 compose to-string now/date return
	label "Auteur" wf4: field prog-author return
	label "But du script" wf5: area "..." wrap 200x40 return
	label "Commentaires" wf6: area prog-comment wrap 200x40 return
	label "Aide (texte/fichier)" wf7: area prog-help wrap 200x40 return
	bar return
	label "fentre  propos" wr1: mrtr first liste-apropos [unfocus]
	pad 20 mbtn "Voir" [
		ssh:  compose-header
		do do to-word wr1/text
		] return
	label "fentre principale" wr2: mrtr first liste-main [unfocus]
	pad 20 mbtn "Voir" [
		bbb: get reduce to-word wr2/text
		replace bbb "system/view" "system/vw" ; pour viter des pb
		replace bbb "view" "view/new"
		replace bbb "system/vw" "system/view"
		replace bbb "[quit]" "[unview main]"
		ssh:  compose-header
		do bbb
		;replace bbb "view/new " "view "
		replace bbb "view/new" "view"
		replace bbb "[unview main]" "[quit]"
	] return
	bar return
	pad 38
	;mbtn "anamon" [do %anamonitor.r] 
	mbtn "Aide" [sshh: system/script/header/help either file?  sshh [error? try [browse sshh]][alert sshh]]
	pad 20
	mbtn "Crer" [
		def-blk: reduce [to-word wr1/text to-word wr2/text]
		compose-file to-file wf2/text def-blk
		if (exists? to-file wf2/text) [if not request/confirm rejoin ["Le fichier " wf2/text " existe dj !" newline " Le remplacer ?"] [break]]
		write to-file wf2/text clean-script script-composer/out alert rejoin ["Le script " wf2/text " a t cr"]
	]
	mbtn "Editer" [if (exists? to-file wf2/text) [editor to-file wf2/text]]
	pad 20
	btn-cancel 60 "Quitter" [quit]
]
main-win-wizard/effect: [gradient 0x1]

foreach el next liste-apropos [append wr1/texts el]
foreach el next liste-main [append wr2/texts el]

view main-win-wizard
do-events